winstd::cert_store Class Reference
Cryptography API

HCERTSTORE wrapper class. More...

`#include <WinStd/Crypt.h>`

Inheritance diagram for winstd::cert_store:

## Public Member Functions

virtual | ~cert_store ()
| Closes the certificate store. More...
bool | create (LPCSTR lpszStoreProvider, DWORD dwEncodingType, HCRYPTPROV_LEGACY hCryptProv, DWORD dwFlags, const void *pvPara) noexcept
| Opens the certificate store. More...
bool | create (HCRYPTPROV_LEGACY hCryptProv, LPCTSTR szSubsystemProtocol) noexcept
| Opens the most common system certificate store. To open certificate stores with more complex requirements, such as file-based or memory-based stores, use `create()`. More...
Public Member Functions inherited from winstd::handle< HCERTSTORE, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle. More...
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor. More...
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle. More...
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment. More...
| operator handle_type () const
| Auto-typecasting operator. More...
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.). More...
handle_type * | operator& ()
| Returns the object handle reference. More...
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct. More...
bool | operator! () const
| Tests if the object handle is INVAL. More...
bool | operator< (handle_type h) const
| Is handle less than? More...
bool | operator<= (handle_type h) const
| Is handle less than or equal to? More...
bool | operator>= (handle_type h) const
| Is handle greater than or equal to? More...
bool | operator> (handle_type h) const
| Is handle greater than? More...
bool | operator!= (handle_type h) const
| Is handle not equal to? More...
bool | operator== (handle_type h) const
| Is handle equal to? More...
void | attach (handle_type h) noexcept
| Sets a new object handle for the class. More...
handle_type | detach ()
| Dismisses the object handle from this class. More...
void | free ()
| Destroys the object.

## Protected Member Functions

void | free_internal () noexcept override
| Closes the certificate store. More...
virtual void | free_internal () noexcept=0
| Abstract member function that must be implemented by child classes to do the actual object destruction. More...

## Additional Inherited Members

Public Types inherited from winstd::handle< HCERTSTORE, NULL >
typedef HCERTSTORE | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< HCERTSTORE, NULL >
static const HCERTSTORE | invalid
| Invalid handle value.
Protected Attributes inherited from winstd::handle< HCERTSTORE, NULL >
handle_type | m_h
| Object handle.

## Detailed Description

HCERTSTORE wrapper class.

## Constructor & Destructor Documentation

## ~cert_store()

virtual winstd::cert_store::~cert_store | ( |  | ) |

inlinevirtual

Closes the certificate store.

See also
  CertCloseStore function

## Member Function Documentation

## create() [1/2]

bool winstd::cert_store::create | ( | HCRYPTPROV_LEGACY | hCryptProv,
|  | LPCTSTR | szSubsystemProtocol
| ) |  |

inlinenoexcept

Opens the most common system certificate store. To open certificate stores with more complex requirements, such as file-based or memory-based stores, use `create()`.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  CertOpenSystemStore function

## create() [2/2]

bool winstd::cert_store::create | ( | LPCSTR | lpszStoreProvider,
|  | DWORD | dwEncodingType,
|  | HCRYPTPROV_LEGACY | hCryptProv,
|  | DWORD | dwFlags,
|  | const void * | pvPara
| ) |  |

inlinenoexcept

Opens the certificate store.

Returns
  - true when creation succeeds;
  - false when creation fails. For extended error information, call `GetLastError()`.

See also
  CertOpenStore function

## free_internal()

void winstd::cert_store::free_internal | ( |  | ) |

inlineoverrideprotectedvirtualnoexcept

Closes the certificate store.

See also
  CertCloseStore function

Implements winstd::handle< HCERTSTORE, NULL >.

The documentation for this class was generated from the following file:

- include/WinStd/Crypt.h